<xsl:stylesheet version="1.0"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:html="http://www.w3.org/1999/xhtml"
  exclude-result-prefixes="xsl html">

  <xsl:output method = "html" omit-xml-declaration = "yes"/> 

  <xsl:param name="portlet-url" select="/"/>
  <xsl:param name="href-param" select="url"/>
  <xsl:param name="href-context" select="."/>

  <xsl:template match="@*|node()">
    <xsl:copy>
      <xsl:apply-templates select="@*|node()"/>
    </xsl:copy>
  </xsl:template>

  <xsl:template match="html:title">
     <xsl:comment><xsl:value-of select="text()"/></xsl:comment>
  </xsl:template>

  <xsl:template match="a">
    <xsl:call-template  name = "anchor"/>
  </xsl:template>

  <xsl:template match="html:a" name="anchor">
     <xsl:variable name="url" select="@href"/>
     <xsl:element name="a">
        <xsl:attribute name="href">
          <xsl:choose>
            <xsl:when test="contains($url, '://')">
              <xsl:value-of select="$url"/>
            </xsl:when>
            <xsl:when test="starts-with($url, 'mailto:')">
              <xsl:value-of select="$url"/>
            </xsl:when>
            <xsl:when test="starts-with($url, 'news:')">
              <xsl:value-of select="$url"/>
            </xsl:when>
            <xsl:when test="starts-with($url, 'javascript:')">
              <xsl:value-of select="$url"/>
            </xsl:when>
            <xsl:otherwise>
              <xsl:variable name="in-param" select="substring-after($url, '?')"/>
              <xsl:variable name="in-query" select="substring-before($url, '?')"/>
              <xsl:value-of select="$portlet-url"/>
              <xsl:choose>
                <xsl:when test="string-length($portlet-url)>0">
                  <xsl:text>&amp;</xsl:text>
                </xsl:when>
                <xsl:otherwise>
                  <xsl:text>?</xsl:text>
                </xsl:otherwise>
              </xsl:choose>
              <xsl:if test="string-length($in-param)>0">
                <xsl:value-of select="$in-param"/>
                <xsl:text>&amp;</xsl:text>
              </xsl:if>
              <xsl:value-of select="$href-param"/>
              <xsl:text>=</xsl:text>
              <xsl:value-of select="$href-context"/>
              <xsl:choose>
                <xsl:when test="string-length($in-query)>0">
                  <xsl:value-of select="$in-query"/>
                </xsl:when>
                <xsl:otherwise>
                  <xsl:value-of select="$url"/>
                </xsl:otherwise>
              </xsl:choose>
            </xsl:otherwise>
           </xsl:choose>
        </xsl:attribute>
        <xsl:copy-of select="*"/> 
        <xsl:value-of select="text()"/> 
     </xsl:element>
  </xsl:template>

</xsl:stylesheet>

